#!/bin/sh

set -x
umask 022

#
# check if critical proccesses are running
#
# The following is a sample configuration line to set this up as a cron job:
#
# 6,12,18,24,30,36,42,48,52,58 * * * * /etc/checkproc.sh > /dev/null 2>&1
#
# You will need to change the path "/etc/checkproc.sh" to reflect where 
# this file actually is on your system.
#
# To add this as a cron job, su to root and type 'crontab -e'.  Then add 
# this line anywhere in the file (at the bottom is fine).  Save and exit,
# and this script should run quite handily.
#
# This script assumes that you keep the tpd program in /usr/local/bin.  
# If this is not the case, simply change the following line:
tpd_path=/home/stats/bin/tpd

# If you want to be notified by mail when the daemon is restarted, set your
# desired e-mail address on the next line and uncomment the line that begins 
# "#/usr/ucb/mail" below.
mail_address="vecna@merit.edu"

ps -ef | grep -v 'xntpd' | grep 'tpd$' > /dev/null 2>&1
if [ $? -ne 0 ]; then
        /usr/ucb/mail -s "tpd is dead, restarting on `hostname `" $mail_address < /dev/null
        $tpd_path/tpd -f $tpd_path/tpd.cfg &
fi
