#ifndef _TRACE_H_
#define _TRACE_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <arpa/inet.h>
#include <sys/time.h>

#include "hopList.h"

#define	BUFSIZE		32
#define NUM_PROBES	1
#define DEFAULT_DPORT	32768 + 666

struct rec {				// format of outgoing UDP data
	u_short rec_seq;		// sequence number
	u_short rec_ttl;		// TTL packet left with
	struct timeval rec_tv;		// time packet left
};

typedef struct proto {
	char *(*icmpcode) (int);
	int (*recv) (struct proto *, int, struct timeval *,
		char *, int, int);
	struct sockaddr *sasend;	// sockaddr{} for send, from getaddrinfo
	struct sockaddr *sarecv;	// sockaddr{} for receiving
	struct sockaddr *salast;	// last sockaddr{} for receiving
	struct sockaddr *sabind;	// sockaddr{} for binding source port
	int salen;			// length of sockaddr{}s
	int icmpproto;			// IPPROTO_xxx value for ICMP
	int ttllevel;			// setsockopt() level to set TTL
	int ttloptname;			// setsockopt() name to set TTL
	int sendfd, recvfd;		// send on UDP sock, read on raw ICMP sock
	u_short	dport,
		sport;
} Proto;

/* function prototypes */
char *icmpcode_v4(int);
char *icmpcode_v6(int);

int recv_v4(Proto *, int, struct timeval *, char *, int, int);
int recv_v6(Proto *, int, struct timeval *, char *, int, int);

void	sig_alrm(int);
void	tv_sub(struct timeval *, struct timeval *);

#ifdef	IPV6
#include	"ip6.h"			// should be <netinet/ip6.h>
#include	"icmp6.h"		// should be <netinet/icmp6.h>
#endif

#endif
